#include "WorldClock.h"

SDL_mutex *WorldClock::singleton_lock = NULL;
WorldClock *WorldClock::instance = NULL;

WorldClock *WorldClock::WC()
{
	if(instance == NULL) {
		singleton_lock = SDL_CreateMutex();
		SDL_mutexP(singleton_lock);
		if(instance == NULL) {
			instance = new WorldClock();
		}
		SDL_mutexV(singleton_lock);
	}
	return instance;
}

WorldClock::WorldClock(const WorldClock &)
{
}

WorldClock &WorldClock::operator= (const WorldClock &)
{
	return *this;
}

void WorldClock::Die()
{
	SDL_mutexP(singleton_lock);
	if(instance != NULL) delete instance;
	instance = NULL;
	SDL_mutexV(singleton_lock);
	SDL_DestroyMutex(singleton_lock);
}
